$MOD51
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING

;*************************************************************
;*
;*	TEPLOMER s komunikaci RS232
;*
;*	cidlo SMARTEC      
;*
;*************************************************************
;
;****** Deklarace symbolickych jmen ******************


	stovky		equ	30h
	desitky		equ	31h
	jednotky	equ	32h
	desetiny	equ	33h
	pocetmerl	equ 	34h
	pocetmerh	equ	35h
        zmerenol	equ 	36h
        zmerenom	equ	37h
        zmerenoh	equ 	38h
        pomstupl	equ 	39h
        pomstuph	equ 	3ah
	thh0		equ	3bh
	anoda		equ	3cH


;Bitove promenne
        namereno       	bit     0
	dekada		bit	1
	merperiod	bit	2
	minus		bit	3

;Hardware
	sto     	bit     p3.3
	des	 	bit	p3.4
        jed	        bit     p3.5
	desjed		bit	p3.7        

;Kalibracni konstanty
posun0c		equ	680		;posun 0 stupnu celsia od zacatku
merenisirky	equ	2127		;pocet desetin stupne na sirku 1


;************ Zacatek programu ***********************

              org 	0000h
              jmp 	Restart

              org 	0003h			;preruseni EX0,hranou
              jmp 	prerus_t0

prerus_t0:    	push	psw			;uschovej pouzivane
		push	acc
;		push	dph
;		push	dpl
		jnb	tf0,prerust0a
		inc	thh0
		clr	tf0
prerust0a:	djnz	pocetmerl,dale
		djnz	pocetmerh,dale
preust0b:	
		jb	merperiod,prerust0c
		mov	zmerenol,tl0		;uloz namerenou sirku - celkova doba kterou byl signal v H po dobu vzorkovani (2127)
		mov	zmerenom,th0
		mov	zmerenoh,thh0
		mov	pocetmerl,#16		;delka mereni 0.1stupne
		mov	pocetmerh,#0+1		;korekce djnz pro 0
		clr	tr0
		mov	tl0,#0			;
		mov	th0,#0
		mov	tmod,#00100001b		;moduj T0 - cita kontinualne zrus gate u citace
		setb	tr0
		setb	merperiod
		sjmp	dale
		
prerust0c:	mov	pocetmerl,#low(merenisirky)		;bude se merit sirka
		mov	pocetmerh,#(high(merenisirky))+1	;pocet cyklu	
		clr	tr0
		mov	tmod,#00101001b			;moduj T0 / citej jen pri gate cili delku jednicky
		mov	pomstupl,tl0			;uloz namerenou hodnotu 0.1stupne
		mov	pomstuph,th0
		mov	tl0,#0
		mov	th0,#0
		clr	tf0
		mov	thh0,#0
		setb	tr0
		clr	merperiod
		setb	namereno

;----------------Zobrazovani na displej-----------------------------
dale:		SETB	sto		;zhasni minule cislo
		SETB	des
		SETB	jed
		SETB	desjed
		
		MOV DPTR,#tabznak	;nacti prvni adresu tabulky znaku
		MOV A,anoda
		CJNE A,#04,pokr_01	;anoda stovky
		MOV A,stovky		;nacti hodnotu v BCD
		JZ znamenko		;pokud jsou nula, zobraz bud minus nebo nic		
pokr_04:	CALL reprezentace	;vole vyslani na port
		CLR	sto		;sepni anodu
		DEC	anoda
		SJMP	konprerus	;ven

znamenko:	JNB	minus,prazdno
		MOV	A,#0AH		;zadej reprezentaci pro pomlcku		
		SJMP	pokr_04		;vrat se
prazdno:	MOV	A,#0BH		;zadej reprezentaci pro prazdny znak
		SJMP	pokr_04		;vrat se
;-------------------------------------------------------------------------------------
pokr_01:	CJNE A,#03,pokr_02	;anoda desitky
		MOV A,desitky		;nacti hodnotu v BCD
		JZ pokr_05		;pokud jsou desitky nula, nezobrazuj
pokr_06:	CALL	reprezentace	;volej vyslani na port
		CLR	des		;sepni anodu
		DEC	anoda
		SJMP	konprerus	;ven

pokr_05:	MOV A,stovky		;nacti stovky
		JZ	pokr_07		;pokud jsou stovky nula, a desitky take, nezobrazuj nuly
		MOV A,#0H		;stovky nejsou nula, u desitek zobraz nulu
		SJMP	pokr_06

pokr_07:		MOV A,#0BH		;zadej reprezentaci pro prazdny znak
		SJMP	pokr_06
;-------------------------------------------------------------------------------------
pokr_02:	CJNE A,#02,pokr_03	;anoda jednotky
		MOV A,jednotky		;nacti hodnotu v BCD
		CALL	reprezentace	;volej vyslani na port
		CLR	P1.7		;rozsvit tecku
		CLR	jed		;sepni anodu
		DEC	anoda
		SJMP	konprerus	;ven
;-------------------------------------------------------------------------------------
pokr_03:				;anoda desetiny
		MOV A,desetiny		;nacti hodnotu v BCD
		CALL	reprezentace	;volej vyslani na port
		CLR	desjed		;sepni anodu
		MOV	anoda,#4	;zadej pocatecni hodnotu pro dalsi smycku displeje
		SJMP	konprerus	;ven

;-----------------------------------------------------------------------------------
reprezentace:	MOVC A,@A+DPTR		;neni nula cti reprezentaci cisla v tabulce
		CPL	A		;otoc
		MOV	P1,A		;posli na port
		RET
;-----------------------------------------------------------------------------------
	
		
konprerus:	;pop	dpl
		;pop	dph
		pop	acc			;obnov pouziva v preruseni
		pop	psw	
		reti
		

;*********** Zacatek hlavniho programu *******************

Restart:      	
		setb	P3.7          

	      mov  	sp,#70h
              mov  	stovky,#0h
              mov  	desitky,#0h              ;vsechny rady vypnuty
              mov  	jednotky,#0h
              mov  	desetiny,#0h
              MOV	anoda,#4	;zadej pocatecni hodnotu pro dalsi smycku displeje              

	      mov	p1,#0BFH		;pri nepripojenem cidlu rozsvit vsude pomlcky
	      CLR	sto		;sepni katody
	      CLR	des
	      CLR	jed
	      CLR	desjed              






	      clr  	minus			;nuluj priznak zaporne teploty
	      mov	pocetmerh,#1
	      mov	pocetmerl,#1
Start:        mov  	IE,#10000001b        ; pouze peruseni od t0
              mov  	TMOD,#00101001b      ; t1 - 8bit s predvolbou
                        	             ; t0 - 16bit s gate
              mov  	TCON,#00000001b      ; int0 reaguje na sestupnou hranu 
              mov  	th1,#0fdh;	     ; 19200 bd
              mov	87h,#10000000b	     ; smod =1	
              setb	tr0
	      setb	tr1
	      mov   	scon,#01010000b
	      clr  	namereno             ;nuluj priznak ukonceni mereni
              mov	r2,#2
ignoruj:      jnb	namereno,ignoruj     ;prvni mereni chybna	
	      clr	namereno
	      djnz	r2,ignoruj

Znovu:        jnb	namereno,znovu		;cekej az bude zmereno
	      clr	namereno

;************ Zacatek aritmetiky ********************
		mov	r2,#4
nasob:		mov	a,zmerenol		;nasob namerenou sirku 16x
	 	clr	c
 		rlc	a
 		mov	zmerenol,a
 		mov	a,zmerenom
 		rlc	a
 		mov	zmerenom,a
 		mov	a,zmerenoh
 		rlc	a
 		mov	zmerenoh,a
 		djnz	r2,nasob
		call	odcitej		;vypocti abs. pocet 0.1 stupnu
		clr	c	
		mov	a,r2
		subb	a,#low(posun0c)	;koriguj posun nuly stupnu
		mov	r2,a
		mov	a,r3
	 	subb	a,#high(posun0c)
		mov	r3,a
		mov	minus,c		;zobraz minus
		jnc	kladna
		clr	a		;koriguj hodnotu minus ( 0-x)
		clr	c
		subb	a,r2
		mov	r2,a
		clr	a
		subb	a,r3
		mov	r3,a
kladna:	
		mov	zmerenol,r2		;preved na dekadicke cislo
		mov	zmerenom,r3
		mov	zmerenoh,#0		
		mov	pomstupl,#low(1000)	;vypocti stovky stupnu
		mov	pomstuph,#high(1000)
		call	odcitej
		mov	stovky,r2
		mov	pomstupl,#low(100)	;vypocti desitky stupnu
		mov	pomstuph,#high(100)
	 	call	odcitej
		mov	desitky,r2
		mov	a,zmerenol
		mov	b,#10
		div	ab			;vypocti jednotky stupnu
		mov	jednotky,a			;zbytek desetiny
		mov	desetiny,b
;		mov	a,stovky		
;		jz	pod100			;pres 100 je chyba
;		mov	desitky,#0eh		;zobrazuj t
;		mov	jednotky,#0eh
;		mov	desetiny,#0eh	
pod100:			
		

;*********Seriova komunikace************************

vysilani:
	mov	a,#20h		;vysli znamenko
	jnb	minus,neminus
	mov	a,#'-'
neminus:call	vysznak
	mov	a,desitky	;vysli desitky stupnu
	call	vyscislo
	mov	a,jednotky
	call	vyscislo
	mov	a,desetiny
	call	vyscislo
	mov	a,#13
	call    vysznak		;konec prenosu CR
	jmp	znovu


vyscislo:  
	   add		a,#30h	        ;koriguj na ASCII
vysznak:   mov   	sbuf,a        	;vysli
	   jnb   	ti,$		;cekej na vyslani
 	   clr   	ti			 		 	
	   ret	


odcitej:	mov	r2,#255		;delit odcitanim
		mov	r3,#255		;v r2,3 vysledek
odcitej1:	inc	r2
		cjne	r2,#0,odcitej2
		inc	r3
odcitej2:	mov	a,zmerenol
		clr	c
		subb	a,pomstupl
		mov	zmerenol,a
		mov	a,zmerenom
		subb	a,pomstuph
		mov	zmerenom,a
		mov	a,zmerenoh
		subb	a,#0
		mov	zmerenoh,a
		jnc	odcitej1
		mov	a,pomstupl
		add	a,zmerenol
		mov	zmerenol,a
		mov	a,pomstuph
		addc	a,zmerenom
		mov	zmerenom,a
		clr	a
		addc	a,zmerenoh
		mov	zmerenoh,a
		ret


;********* Konec programu ****************              		

tabznak:        DB 63,6,91,79,102,109,125,7,127,111,64,0
;reprezentace cisel       0,1,2 , 3, 4 , 5 , 6 ,7 ,8 , 9 , -,prazdny znak


                end